unit FrmMain;

{
  BLUE HELL software.

  Copyright (C) 1999 .. 2012, Jan Punter.

  Notes :

    midi componenets needed : http://sourceforge.net/projects/dmidi/
    hires timer needed      : source code included ... I may have stolen that somewhere without
                              acknowleging the source .. somewhere in 1999 or so ...
                              It sure looks a lot like : http://www.programmersheaven.com/download/2818/1/ZipView.aspx
                              but details as to the origin seem absent there too.


    THiResTim module needs to be installed.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

}

interface

uses

  Windows, Messages, SysUtils, Classes, Controls, Forms, Menus, ExtCtrls,
  Buttons, Dialogs, StdCtrls, mmSystem, FrmMidDlg, MidiOut, MidiIn, MidiType,
  Globals, Modules, MoreMods, IniFiles, HiResTim, FrmAbout, FrmRndSet,
  ComCtrls, Graphics, ShellApi;

type
  TFormMain = class(TForm)
    PanelTop: TPanel;
    MainMenu1: TMainMenu;
    MenuItemFile: TMenuItem;
    MenuItemFileExit: TMenuItem;
    MenuItemModuleDelete: TMenuItem;
    MenuItemModuleDeleteall: TMenuItem;
    MenuItemFileDeleteAll: TMenuItem;
    MenuItemSlotSave: TMenuItem;
    MenuItemSlotSaveAs: TMenuItem;
    MenuItemSlotOpen: TMenuItem;
    N3: TMenuItem;
    MenuItemSlotSaveAll: TMenuItem;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    Debug1: TMenuItem;
    Dump1: TMenuItem;
    Options1: TMenuItem;
    Midi1: TMenuItem;
    MidiInput: TMidiInput;
    MidiOutput: TMidiOutput;
    HiResTimerExec: THiResTimer;
    Help1: TMenuItem;
    About1: TMenuItem;
    TimerScreenUpdates: TTimer;
    New1: TMenuItem;
    N1: TMenuItem;
    MenuItemFileDelete: TMenuItem;
    N2: TMenuItem;
    Randomsettings1: TMenuItem;
    N4: TMenuItem;
    HelpManual: TMenuItem;
    N5: TMenuItem;
    Colors1: TMenuItem;
    ColorDialog: TColorDialog;
    Modulecolor1: TMenuItem;
    Asymmetriccolor1: TMenuItem;
    Symmetriccolor1: TMenuItem;
    Logiccolor1: TMenuItem;
    Neuroncolor1: TMenuItem;
    Knobcolor1: TMenuItem;
    LedColoron1: TMenuItem;
    Ledcoloroff1: TMenuItem;
    Viewercolor1: TMenuItem;
    Scopecolor1: TMenuItem;
    PanelTopLeft: TPanel;
    PanelTopRight: TPanel;
    PanelTopRightTop: TPanel;
    SpeedButtonStartStop: TSpeedButton;
    SpeedButtonRandomize: TSpeedButton;
    SpeedButtonAllNotesOff: TSpeedButton;
    PanelTopRightBottom: TPanel;
    Label2: TLabel;
    ImageStop: TImage;
    ImageStart: TImage;
    Edit1: TMenuItem;
    N6: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    N7: TMenuItem;
    Selectall1: TMenuItem;
    Invertselection1: TMenuItem;
    N8: TMenuItem;
    ShapeOverflow: TShape;
    procedure FormCreate(Sender: TObject);
    procedure MenuItemFileExitClick(Sender: TObject);
    procedure MenuItemModuleAddModuleClick(Sender: TObject);
    procedure MenuItemModuleDeleteallClick(Sender: TObject);
    procedure MenuItemModuleDeleteClick(Sender: TObject);
    procedure MenuItemFileNewClick(Sender: TObject);
    procedure MenuItemFileDeleteClick(Sender: TObject);
    procedure MenuItemFileDeleteAllClick(Sender: TObject);
    procedure Dump1Click(Sender: TObject);
    procedure MenuItemSlotSaveClick(Sender: TObject);
    procedure MenuItemSlotSaveAllClick(Sender: TObject);
    procedure MenuItemSlotSaveAsClick(Sender: TObject);
    procedure MenuItemSlotOpenClick(Sender: TObject);
    procedure HiResTimerExecTimer(Sender: TObject);
    procedure SpeedButtonStartStopClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Midi1Click(Sender: TObject);
    procedure MidiInputMidiInput(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure TimerScreenUpdatesTimer(Sender: TObject);
    procedure Randomsettings1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpeedButtonRandomizeClick(Sender: TObject);
    procedure HelpManualClick(Sender: TObject);
    procedure SpeedButtonAllNotesOffClick(Sender: TObject);
    procedure Modulecolor1Click(Sender: TObject);
    procedure Asymmetriccolor1Click(Sender: TObject);
    procedure Symmetriccolor1Click(Sender: TObject);
    procedure Logiccolor1Click(Sender: TObject);
    procedure Neuroncolor1Click(Sender: TObject);
    procedure Knobcolor1Click(Sender: TObject);
    procedure LedColoron1Click(Sender: TObject);
    procedure Ledcoloroff1Click(Sender: TObject);
    procedure Viewercolor1Click(Sender: TObject);
    procedure Scopecolor1Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Selectall1Click(Sender: TObject);
    procedure Invertselection1Click(Sender: TObject);
  private
      FModulePageControl : TMimModulePageControl;
      FModuleSelector    : TMimmoduleSelector;
      FConnectionCount   : Integer;
      FRunning           : Boolean;
      FExecTime          : Integer;
      FMidiIn            : String;
      FMidiOut           : String;
      FPreMidiIn         : String;
      FPreMidiOut        : String;
      FMidiInOpen        : Boolean;
      FMidiOutOpen       : Boolean;
      // Fresolution        : Integer;
      FRandomized        : Boolean;
      FRandomSeed        : LongInt;
      FOrigCaption       : String;
      FLastLoadPath      : String;
      FLastSavePath      : String;
      FLastClickedDetail : TObject;
      FPreResolution     : Integer;
      FPreAccuracy       : Integer;

    Procedure   SetConnectionCount( aValue: Integer);
    Procedure   SetRunning        ( aValue: Boolean);
    Procedure   SetMidiIn         ( Const aValue: String);
    Procedure   SetMidiOut        ( Const aValue: String);
    Procedure   SetMidiInOpen     ( aValue: Boolean);
    Procedure   SetMidiOutOpen    ( aValue: Boolean);
    // Procedure   SetResolution     ( aValue: Integer);

    Function    SelectColor( Var aColor: TColor): Boolean;
    Procedure   SetModuleColor;
    Procedure   SetAssymetricColor;
    Procedure   SetSymmetricColor;
    Procedure   SetLogicColor;
    Procedure   SetNeuronColor;
    Procedure   SetKnobColor;
    Procedure   SetLedColorOn;
    Procedure   SetLedColorOff;
    Procedure   SetViewerColor;
    Procedure   SetScopeColor;

    Procedure   CutSelection;
    Procedure   CopySelection;
    Procedure   PasteSelection;
    Procedure   SelectAllModules;
    Procedure   InvertModuleSelection;

    Procedure   DoModulePageControlCountChange      ( Sender: TObject; aCount: Integer);
    Procedure   DoModulePageControlModuleCountChange( Sender: TObject; aCount: Integer);
    Procedure   DoModuleButtonClick( aSender: Tobject; aModuleClass: TMimModuleClass);
    Procedure   DoConnectionMade( aSender: TObject; aSource, aDestination: TMimConnector);
    Procedure   DoConnectionLost( aSender: TObject; aSource, aDestination: TMimConnector);
    Procedure   DoActiveSlotChange( aSender: TObject; Const aPageName: String);
    Procedure   DoModulePageControlClick   ( aSender: TObject);
    Procedure   DoModulePageControlDblClick( aSender: TObject);
    Procedure   InitTiming;
    Procedure   ShowTiming;
    Procedure   SendMidiShort( aSender: TObject;       aShortMidi: TShortMidi);
    Procedure   SendMidiLong ( aSender: TObject; Const aLongMidi : TLongMidi );
    Procedure   PerformAllNotesOff;

    Procedure   ExtendCaption( Const S: String);
    Procedure   AcceptCommandLine( aCommandLine: Atom);

    Procedure   SaveIni;
    Procedure   LoadIni;

    Property    ConnectionCount: Integer Read FConnectionCount Write SetConnectionCount;
    Property    Running        : Boolean Read FRunning         Write SetRunning;
    Property    MidiIn         : String  Read FMidiIn          Write SetMidiIn;
    Property    MidiOut        : String  Read FMidiOut         Write SetMidiOut;
    Property    MidiInOpen     : Boolean Read FMidiInOpen      Write SetMidiInOpen;
    Property    MidiOutOpen    : Boolean Read FMidiOutOpen     Write SetMidiOutOpen;
    // Property    Resolution     : Integer Read FResolution      Write SetResolution;
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

implementation

{$R *.DFM}

{
  User area
}

// Some special stuff used by a second invocation.

Var

  OldWindowProc : Pointer; // Variable for the old windows proc
  MyMsg         : DWord;   // Custum systemwide message

  Function NewWindowProc(
    aWindowHandle: hWnd;
    aMessage     : Cardinal;
    aParamW      : LongInt;
    aPAramL      : LongInt
  ): LongInt stdCall;
  Begin
    If aMessage = MyMsg
    Then Begin
      SendMessage( Application.Handle, WM_SYSCOMMAND, SC_RESTORE, 0);
      SetForeGroundWindow( Application.Handle);
      FormMain.AcceptCommandLine( Atom( aParamW));
      Result := 0;
      Exit;
    End;
    Result :=
      CallWindowProc( OldWindowProc, aWindowHandle, aMessage, aParamW, aParamL);
  End;

    Procedure   TFormMain.SetConnectionCount( aValue: Integer);
    Begin
      FConnectionCount := aValue;
    End;

    Procedure   TFormMain.SetRunning( aValue: Boolean);
    Begin
      If Frunning <> aValue
      Then Begin
        FRunning := aValue;
        With HiResTimerExec Do
        If FRunning
        Then Begin
          Interval   := FPreResolution;
          Resolution := FPreAccuracy;
          If Not Enabled
          Then Enabled := True
          Else Resume;
        End
        Else Pause;
        // HiResTimerExec.Enabled := FRunning;
        With SpeedButtonStartStop Do
          Case FRunning Of
            False : Begin
                Hint  := 'Start [F12]';
                Glyph := ImageStart.Picture.Bitmap;
              End;
            True  : Begin
                Hint  := 'Stop [F12]';
                Glyph := ImageStop.Picture.BitMap;
              End;
          End;
      End;
    End;

    Procedure   TFormMain.SetMidiIn( Const aValue: String);
    Var
      WasOpen : Boolean;
    Begin
      WasOpen := MidiInOpen;
      If WasOpen
      Then MidiInOpen := False;
      Try
        With MidiInput Do
        Begin
          ProductName := aValue;
        End;
        If WasOpen
        Then MidiInOpen := True;
        FMidiIn := aValue;
      Except
        On E:Exception Do
          ShowMessageFmt( 'Could not open midi in port : %s', [ E.Message]);
      End;
    End;

    Procedure   TFormMain.SetMidiOut( Const aValue: String);
    Var
      WasOpen : Boolean;
    Begin
      WasOpen := MidiOutOpen;
      If WasOpen
      Then MidiOutOpen := False;
      Try
        With MidiOutput Do
        Begin
          ProductName := aValue;
        End;
        If WasOpen
        Then MidiOutOpen := True;
        FMidiOut := aValue;
      Except
        On E:Exception Do
          ShowMessageFmt( 'Could not open midi out port : %s', [ E.Message]);
      End;
    End;

    Procedure   TFormMain.SetMidiInOpen( aValue: Boolean);
    Begin
      If aValue <> FMidiInOpen
      Then Begin
        If aValue
        Then
          With MidiInput Do
          Begin
            Open;
            Start;
            FMidiInOpen := True;
          End
        Else
          With MidiInput Do
          Begin
            Try
              Stop;
            Finally
              Close;
              FMidiInOpen := False;
            End;
          End;
      End;
    End;

    Procedure   TFormMain.SetMidiOutOpen( aValue: Boolean);
    Begin
      If aValue <> FMidiOutOpen
      Then Begin
        If aValue
        Then MidiOutput.Open
        Else MidiOutput.Close;
        FMidiOutOpen := aValue;
      End;
    End;

    {
    Procedure   TFormMain.SetResolution( aValue: Integer);
    Begin
      With HiResTimerExec Do
      Begin
        Resolution := aValue Div 10;
        Interval   := aValue;
      End;
      FResolution := aValue;
    End;
    }

    Function    TFormMain.SelectColor( Var aColor: TColor): Boolean;
    Begin
      Result := False;
      With ColorDialog Do
      Begin
        Color := aColor;
        If Execute
        Then Begin
          aColor := Color;
          Result := True;
          If Assigned( FModulePageControl)
          Then FModulePageControl.Recolorize;
        End;
      End;
    End;

    Procedure   TFormMain.SetModuleColor;
    Begin
      SelectColor( ModuleColor);
    End;

    Procedure   TFormMain.SetAssymetricColor;
    Begin
      SelectColor( AsymmetricColor);
    End;

    Procedure   TFormMain.SetSymmetricColor;
    Begin
      SelectColor( SymmetricColor);
    End;

    Procedure   TFormMain.SetLogicColor;
    Begin
      SelectColor( LogicColor);
    End;

    Procedure   TFormMain.SetNeuronColor;
    Begin
      SelectColor( NeuronColor);
    End;

    Procedure   TFormMain.SetKnobColor;
    Begin
      SelectColor( KnobColor);
    End;

    Procedure   TFormMain.SetLedColorOn;
    Begin
      SelectColor( LedColorOn);
    End;

    Procedure   TFormMain.SetLedColorOff;
    Begin
      SelectColor( LedColorOff);
    End;

    Procedure   TFormMain.SetViewerColor;
    Begin
      SelectColor( ViewerColor);
    End;

    Procedure   TFormMain.SetScopeColor;
    Begin
      SelectColor( GraphBack);
    End;

    Procedure   TFormMain.CutSelection;
    Begin
      With FModulePageControl Do
      Begin
        CopyModulesToClipBoard;
        FreeSelectedModules;
      End;
    End;

    Procedure   TFormMain.CopySelection;
    Begin
      FModulePageControl.CopyModulesToClipBoard;
    End;

    Procedure   TFormMain.PasteSelection;
    Begin
      FModulePageControl.PasteModulesFromClipBoard;
    End;

    Procedure   TFormMain.SelectAllModules;
    Begin
      FModulePageControl.SelectAllModules;
    End;

    Procedure   TFormMain.InvertModuleSelection;
    Begin
      FModulePageControl.InvertModuleSelection;
    End;

    Procedure   TFormMain.DoModulePageControlCountChange( Sender: TObject; aCount: Integer);
    Begin
      MenuItemFileDelete   .Enabled := aCount > 0;
      MenuItemFileDeleteAll.Enabled := aCount > 0;
      MenuItemSlotSave     .Enabled := aCount > 0;
      MenuItemSlotSaveAs   .Enabled := aCount > 0;
      MenuItemSlotSaveAll  .Enabled := aCount > 0;
      If Assigned( FModuleSelector)
      Then FModuleSelector.ButtonsEnabled := aCount > 0;
    End;

    Procedure   TFormMain.DoModulePageControlModuleCountChange( Sender: TObject; aCount: Integer);
    Begin
      MenuItemModuleDelete   .Enabled := aCount > 0;
      MenuItemModuleDeleteAll.Enabled := aCount > 0;
    End;

    Procedure   TFormMain.DoModuleButtonClick( aSender: Tobject; aModuleClass: TMimModuleClass);
    Var
      WasRunning : Boolean;
    Begin
      If Assigned( FModulePageControl)
      Then Begin
        WasRunning := Running;
        Running    := False;
        FModulePageControl.CreateModule( aModuleClass);
        Running := WasRunning;
      End;
    End;

    Procedure   TFormMain.DoConnectionMade( aSender: TObject; aSource, aDestination: TMimConnector);
    Begin
      ConnectionCount := ConnectionCount + 1;
    End;

    Procedure   TFormMain.DoConnectionLost( aSender: TObject; aSource, aDestination: TMimConnector);
    Begin
      ConnectionCount := ConnectionCount - 1;
    End;

    Procedure   TFormMain.DoActiveSlotChange( aSender: TObject; Const aPageName: String);
    Begin
      ExtendCaption( aPageName);
    End;

    Procedure   TFormMain.DoModulePageControlClick( aSender: TObject);
    Begin
      FLastClickedDetail := aSender;
    End;

    Procedure   TFormMain.DoModulePageControlDblClick( aSender: TObject);
    Var
      S : String;
    Begin
      If aSender Is TMimTextLabel
      Then With TMimTextLabel( aSender) Do
      Begin
        S := ( Owner As TMimCustomModule).ClassName;
        S := 'Module type = ' + Copy( S, 2, Length( S));
        Text := InputBox( 'Enter module title', S, Text);
      End
      Else If aSender Is TMimKnob
      Then With TMimKnob( aSender) Do
      Begin
        If KnobMode = kmNone
//        Then Value := StrToInt( InputBox( 'Enter a knob value', 'Value', IntToStr( Value))); @@@@
        Then Value := StrToInt( InputBox( 'Enter a knob value', 'Value', IntToStr( Round( Value))));
      End;
    End;

    Procedure   TFormMain.InitTiming;
    Begin
      FExecTime := 1;
    End;

    Procedure   TFormMain.ShowTiming;
    Begin
      ShapeOverflow.Brush.Color := clGreen;
    End;

    Procedure   TFormMain.SendMidiShort( aSender: TObject; aShortMidi: TShortMidi);
    Var
      aCh     : Byte;
      anEvent : Byte;
      aData1  : Byte;
      aData2  : Byte;
    Begin
      DisAssembleShortMidi( aShortMidi, aCh, anEvent, aData1, aData2);
//      WriteDebugStr( Format( 'MidiOut :: ch=%d, ev=%d, d1=%d, d2=%d', [ aCh, anEvent, aData1, aData2]));
      Try
        If MidiOutOpen
        Then MidiOutput.PutShort( anEvent Shl 4 Or aCh, aData1, aData2);
      Except
        On Exception Do
          ; // Nothing, ignore it.
      End;
    End;

    Procedure   TFormMain.SendMidiLong( aSender: TObject; Const aLongMidi: TLongMidi);
    Begin
      With aLongMidi Do
      If MidiOutOpen
      Then
        Try
          MidiOutput.PutLong( @ Data, Size);
        Except
          On Exception Do
            ;
        End;
    End;

    Procedure   TFormMain.PerformAllNotesOff;
    Var
      i : Integer;
    Begin
      If MidiOutOpen
      Then Begin
        For i := 0 To 15 Do
          Try
            MidiOutput.PutShort(( CControlChange Shl 4) Or i, 123, 0 );
          Except
            On Exception Do
              ;
          End;
      End;
    End;

    Procedure   TFormMain.ExtendCaption( Const S: String);
    Begin
      Caption := Format( '%s - %s', [ FOrigCaption, S])
    End;

    Procedure   TFormMain.AcceptCommandLine( aCommandLine: Atom);
    Const
      BufSize = 1024;
    Var
      Buf : Array[ 0 .. BufSize] Of Char;
      S   : String;
    Begin
      If aCommandLine <> 0
      Then Begin
        GlobalGetAtomName( aCommandLine, Buf, BufSize);
        S := StrPas( Buf);
        Try
          If FileExists( S)
          Then FModulePageControl.Load( S);
        Finally
          GlobalDeleteAtom( aCommandLine);
        End;
      End;
    End;

    Procedure   TFormMain.SaveIni;
    Begin
      With TIniFile.Create( IniFileName) Do
        Try
          WriteInteger( 'Settings', 'Left'           , Left           );
          WriteInteger( 'Settings', 'Top'            , Top            );
          WriteInteger( 'Settings', 'Width'          , Width          );
          WriteInteger( 'Settings', 'Height'         , Height         );
          WriteString ( 'Settings', 'MidiIn'         , FMidiIn        );
          WriteString ( 'Settings', 'MidiOut'        , FMidiOut       );
          WriteBool   ( 'Settings', 'Randomized'     , FRandomized    );
          WriteInteger( 'Settings', 'RandomSeed'     , FRandomSeed    );
          WriteString ( 'Settings', 'LastLoadPath'   , FLastLoadPath  );
          WriteString ( 'Settings', 'LastSavePath'   , FLastSavePath  );
          WriteInteger( 'Colors'  , 'ModuleColor'    , ModuleColor    );
          WriteInteger( 'Colors'  , 'AsymmetricColor', AsymmetricColor);
          WriteInteger( 'Colors'  , 'SymmetricColor' , SymmetricColor );
          WriteInteger( 'Colors'  , 'LogicColor'     , LogicColor     );
          WriteInteger( 'Colors'  , 'NeuronColor'    , NeuronColor    );
          WriteInteger( 'Colors'  , 'KnobColor'      , KnobColor      );
          WriteInteger( 'Colors'  , 'LedColorOn'     , LedColorOn     );
          WriteInteger( 'Colors'  , 'LedColorOff'    , LedColorOff    );
          WriteInteger( 'Colors'  , 'ViewerColor'    , ViewerColor    );
          WriteInteger( 'Colors'  , 'ScopeColor'     , GraphBack      );

          WriteInteger( 'Timing'  , 'Resolution'     , FPreResolution );
          WriteInteger( 'Timing'  , 'Accuracy'       , FPreAccuracy   );

        Finally
          Free;
        End;
    End;

    Procedure   TFormMain.LoadIni;
    Var
      L, T, W, H : Integer;
    Begin
      With TIniFile.Create( IniFileName) Do
        Try
          L              := ReadInteger( 'Settings', 'Left'           , Left           );
          T              := ReadInteger( 'Settings', 'Top'            , Top            );
          W              := ReadInteger( 'Settings', 'Width'          , Width          );
          H              := ReadInteger( 'Settings', 'Height'         , Height         );
          FPreMidiIn     := ReadString ( 'Settings', 'MidiIn'         , FPreMidiIn     );
          FPreMidiOut    := ReadString ( 'Settings', 'MidiOut'        , FPreMidiOut    );
          FRandomized    := ReadBool   ( 'Settings', 'Randomized'     , FRandomized    );
          FRandomSeed    := ReadInteger( 'Settings', 'RandomSeed'     , FRandomSeed    );
          FLastLoadPath  := ReadString ( 'Settings', 'LastLoadPath'   , FLastLoadPath  );
          FLastSavePath  := ReadString ( 'Settings', 'LastSavePath'   , FLastSavePath  );
          ModuleColor    := ReadInteger( 'Colors'  , 'ModuleColor'    , ModuleColor    );
          AsymmetricColor:= ReadInteger( 'Colors'  , 'AsymmetricColor', AsymmetricColor);
          SymmetricColor := ReadInteger( 'Colors'  , 'SymmetricColor' , SymmetricColor );
          LogicColor     := ReadInteger( 'Colors'  , 'LogicColor'     , LogicColor     );
          NeuronColor    := ReadInteger( 'Colors'  , 'NeuronColor'    , NeuronColor    );
          KnobColor      := ReadInteger( 'Colors'  , 'KnobColor'      , KnobColor      );
          LedColorOn     := ReadInteger( 'Colors'  , 'LedColorOn'     , LedColorOn     );
          LedColorOff    := ReadInteger( 'Colors'  , 'LedColorOff'    , LedColorOff    );
          ViewerColor    := ReadInteger( 'Colors'  , 'ViewerColor'    , ViewerColor    );
          GraphBack      := ReadInteger( 'Colors'  , 'ScopeColor'     , GraphBack      );

          FPreResolution := ReadInteger( 'Timing'  , 'Resolution'     , MainTimeResolution   );
          FPreAccuracy   := ReadInteger( 'Timing'  , 'Accuracy'       , FPreResolution Div 10);

          With Screen Do
          Begin
            If ( L < - 8) Or ( L > Width - 50)
            Then L := 0;
            If ( T < - 8) Or ( T > Height - 50)
            Then T := 0;
            If ( W < 640) Or ( W > Width + 16)
            Then W := 640;
            If ( H < 480) Or ( H > Height + 16)
            Then H := 480;
          End;
          Left   := L;
          Top    := T;
          Width  := W;
          Height := H;
        Finally
          Free;
        End;
    End;


{
  Delphi area
}



procedure TFormMain.FormCreate(Sender: TObject);
Var
  aCommandLine : Atom;
  aData        : Array[ 0 .. 1024] Of Char;
begin
  FOrigCaption := Caption;

  MyMsg := RegisterWindowMessage( 'MidiMod7_CommandLine');
  OldWindowProc :=
    Pointer(
      SetWindowLong( FormMain.Handle, GWL_WNDPROC, LongInt( @ NewWindowProc))
    );

  FModuleSelector := TMimmoduleSelector.Create( Self);
  With FModuleSelector Do
  Begin
    Parent := PanelTopLeft;
    Align  := alLeft;
    Width  := Parent.Width;
    OnModuleButtonClick := DoModuleButtonClick;
    RegisterModuleClass( 'I/O'       , TMimMidiIn        );
    RegisterModuleClass( 'I/O'       , TMimMidiOut       );
    RegisterModuleClass( 'I/O'       , TMimControlIn     );
    RegisterModuleClass( 'I/O'       , TMimControlOut    );
    RegisterModuleClass( 'I/O'       , TMimBendIn        );
    RegisterModuleClass( 'I/O'       , TMimBendOut       );
    RegisterModuleClass( 'Gen'       , TMimConstant      );
    RegisterModuleClass( 'Gen'       , TMimSquare        );
    RegisterModuleClass( 'Gen'       , TMimSine          );
    RegisterModuleClass( 'Gen'       , TMimSaw           );
    RegisterModuleClass( 'Gen'       , TMimRandom        );
    RegisterModuleClass( 'Gen'       , TMimRndPulse      );
    RegisterModuleClass( 'Gen'       , TMimClSquare      );
    RegisterModuleClass( 'Gen'       , TMimClSine        );
    RegisterModuleClass( 'Gen'       , TMimClSaw         );
    RegisterModuleClass( 'Gen'       , TMimClRandom      );
    RegisterModuleClass( 'Gen'       , TMimClRndPulse    );
    RegisterModuleClass( 'Logic'     , TMimDividerFixed  );
    RegisterModuleClass( 'Logic'     , TMimFreqDivider   );
    RegisterModuleClass( 'Control'   , TMimAmplifier     );
    RegisterModuleClass( 'Control'   , TMimMultiplier    );
    RegisterModuleClass( 'Control'   , TMimDivider       );
    RegisterModuleClass( 'Control'   , TMimTable         );
    RegisterModuleClass( 'Control'   , TMimNeuron        );
    RegisterModuleClass( 'Control'   , TMimMorph         );
    RegisterModuleClass( 'Control'   , TMimSlotCtrl      );
    RegisterModuleClass( 'Control'   , TMimShifter       );
    RegisterModuleClass( 'Viewers'   , TMimScope         );
    RegisterModuleClass( 'Other'     , TMimModule        );
    RegisterModuleClass( 'Other'     , TMimModule2       );
    RegisterModuleClass( 'Other'     , TMimModule4       );
    RegisterModuleClass( 'Other'     , TMimModule8       );
  End;
  FModulePageControl := TMimModulePageControl.Create( Self);
  With FModulePageControl Do
  Begin
    Parent              := Self;
    Align               := alClient;
    OnCountChange       := DoModulePageControlCountChange;
    OnModuleCountChange := DoModulePageControlModuleCountChange;
    OnConnectionMade    := DoConnectionMade;
    OnConnectionLost    := DoConnectionLost;
    OnActiveSlotChange  := DoActiveSlotChange;
    OnmidiOutShort      := SendMidiShort;
    OnMidiOutLong       := SendMidiLong;
    OnDetailClick       := DoModulePageControlClick;
    OnDetailDblClick    := DoModulePageControlDblClick;
  End;
  // Resolution  := MainTimeResolution; // ms timer resolution
  FMidiIn     := '';
  FMidiOut    := '';
  FPreMidiIn  := '';
  FPreMidiOut := '';

  FConnectionCount := -1;
  ConnectionCount  :=  0;
  FRunning         := True;
  Running          := False;

  FRandomized      := True;
  FRandomSeed      := 0;

  LoadIni; // Reads FPreMidiXxx variables.

  InitTiming;
  ShowTiming;

  Try
    MidiIn  := FPreMidiIn; // FPreMidIn was read from the ini file.
  Except
    On E:Exception Do
      Application.HandleException( E);
  End;
  Try
    MidiOut := FPreMidiOut; // FPreMidOut was read from the ini file.
  Except
    On E: Exception Do
      Application.HandleException( E);
  End;

  Try
    MidiInOpen := MidiIn  <> '';
  Except
    On E:Exception Do
      Application.HandleException( E);
  End;

  Try
    MidiOutOpen := MidiOut <> '';
  Except
    On E:Exception Do
      Application.HandleException( E);
  End;

  If FRandomized
  Then Randomize
  Else RandSeed := FRandomSeed;

    If ParamCount >= 1
    Then Begin
      StrPCopy( @ aData, ParamStr( 1));
      aCommandLine := GlobalAddAtom( aData)
    End
    Else aCommandLine := 0;
  AcceptCommandLine( aCommandLine);

  Running := True;
end;

procedure TFormMain.MenuItemFileExitClick(Sender: TObject);
begin
  Close;
end;

procedure TFormMain.MenuItemModuleAddModuleClick(Sender: TObject);
begin
  DoModuleButtonClick( Self, TMimModule);
end;

procedure TFormMain.MenuItemModuleDeleteallClick(Sender: TObject);
begin
  FModulePageControl.FreeModules;
end;

procedure TFormMain.MenuItemModuleDeleteClick(Sender: TObject);
begin
  FModulePageControl.FreeSelectedModules;
end;

procedure TFormMain.MenuItemFileNewClick(Sender: TObject);
begin
  FModulePageControl.AddSlot( '');
end;

procedure TFormMain.MenuItemFileDeleteClick(Sender: TObject);
begin
  FLastClickedDetail := Nil;
  FModulePageControl.FreeCurrentSlot;
end;

procedure TFormMain.MenuItemFileDeleteAllClick(Sender: TObject);
begin
  FModulePageControl.FreeAllSlots;
end;


procedure TFormMain.Dump1Click(Sender: TObject);
Var
  aFile: TextFile;
begin
  AssignFile( aFile, 'Dump.txt');
  Rewrite( aFile);
  Try
    FModulePageControl.Dump( aFile, 0, 5);
  Finally
    CloseFile( aFile);
  End;
end;


procedure TFormMain.MenuItemSlotSaveClick(Sender: TObject);
begin
  FModulePageControl.Save;
end;

procedure TFormMain.MenuItemSlotSaveAllClick(Sender: TObject);
begin
  FModulePageControl.SaveAll;
end;

procedure TFormMain.MenuItemSlotSaveAsClick(Sender: TObject);
Var
  aFileName : String;
begin
  With FModulePageControl, SaveDialog Do
  Begin
    InitialDir := FLastSavePath;
    If Assigned( ActiveSlot)
    Then aFileName := ActiveSlot.SlotFileName;
    FileName := aFileName;
    If Execute
    Then Begin
      FLastSavePath := ExtractFilePath( FileName);
      SaveAs( FileName);
    End;
  End;
end;

procedure TFormMain.MenuItemSlotOpenClick(Sender: TObject);
begin
  With FModulePageControl, OpenDialog Do
  Begin
    InitialDir := FLastLoadPath;
    If Execute
    Then Begin
      FLastLoadPath := ExtractFilePath( FileName);
      Load( FileName);
    End;
  End;
end;

procedure TFormMain.HiResTimerExecTimer(Sender: TObject);
Var
  aTime : DWORD;
begin
  If Assigned( FModulePageControl)
  Then Begin
    aTime := TimeGetTime;
    If FExecTime < 200
    Then FModulePageControl.Execute
    Else ShapeOverflow.Brush.Color := clRed;
    FExecTime := TimeGetTime - aTime;
  End;
end;

procedure TFormMain.SpeedButtonStartStopClick(Sender: TObject);
begin
  Running := Not Running;
  InitTiming;
end;

procedure TFormMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Running     := False;
  
  With HiResTimerExec Do
  Begin
    Resume;
    Enabled := False;
  End;

  PerformAllNotesOff;
  MidiInOpen  := False;
  MidiOutOpen := False;
end;

procedure TFormMain.Midi1Click(Sender: TObject);
begin
  With FormMididialog Do
  Begin
    InSelection   := MidiIn;
    OutSelection  := MidiOut;
    If ShowModal = mrOk
    Then Begin
      // -- //
      Try
        MidiIn := InSelection;
        If Not MidiInOpen
        Then MidiInOpen := MidiIn <> '';
      Except
        On Exception Do
          ;
      End;
      // -- //
      Try
        MidiOut := OutSelection;
        If Not MidiOutOpen
        Then MidiOutOpen := MidiIn <> '';
      Except
        On Exception Do
          ;
      End;
    End;
  End;
end;


procedure TFormMain.MidiInputMidiInput(Sender: TObject);
Var
  aMidi      : TMyMidiEvent;
  aShortMidi : TShortMidi;
  aLongMidi  : PLongMidi;
  M          : Byte;
begin
  With MidiInput, FModulePageControl Do
  Begin
    aMidi := GetMidiEvent;
    With aMidi Do
      Try
        If SysExLength > 0
        Then Begin
          GetMem( aLongMidi, SizeOf( aLongMidi) + SysExLength);
          With aLongMidi^ Do
          Begin
            Size := SysExLength;
            Move( SysEx^, Data, SysExLength);
          End;
          Try
            AcceptMidiLong( aLongMidi^)
          Finally
            FreeMem( aLongMidi, SizeOf( aLongMidi) + SysExLength);
          End;
        End
        Else Begin
          M := MidiMessage;
          aShortMidi := AssembleShortMidi( M And $0f, M Shr 4, Data1, Data2);
//          WriteDebugStr( Format( 'Midi In :: ch=%d, ev=%d, d1=%d, d2=%d', [ M And $0f, M Shr 4, Data1, Data2]));
          AcceptMidiShort( aShortMidi);
        End;
      Finally
        Free;
      End;
  End;
end;

procedure TFormMain.FormDestroy(Sender: TObject);
begin
  SaveIni;
  SetWindowLong( FormMain.Handle, GWL_WNDPROC, LongInt( OldWindowProc));
end;

procedure TFormMain.About1Click(Sender: TObject);
begin
  FormAbout.ShowModal;
end;

procedure TFormMain.TimerScreenUpdatesTimer(Sender: TObject);
begin
  ShowTiming;
end;

procedure TFormMain.Randomsettings1Click(Sender: TObject);
Var
  WasRunning : Boolean;
begin
  With FormRandomSettings Do
  Begin
    Randomized := Self.FRandomized;
    RandomSeed := Self.FRandomSeed;
    If ShowModal = mrOk
    Then Begin
      Self.FRandomized := Randomized;
      Self.FRandomSeed := RandomSeed;
    End;
  End;
  WasRunning := Running;
  Running := False;
  If FRandomized
  Then Randomize
  Else RandSeed := FRandomSeed;
  Running := WasRunning;
end;

procedure TFormMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  If Shift = []
  Then Begin
    Case Key Of
      VK_F12 : Running := Not Running;
      VK_F2  : Running := Not Running;
      VK_F11 : Randomize;
      VK_F10 : PerformAllNotesOff;
      VK_F5  :
        If WindowState = wsNormal
        Then WindowState := wsMaximized
        Else WindowState := wsNormal;
    End;
  End;
end;


procedure TFormMain.SpeedButtonRandomizeClick(Sender: TObject);
begin
  Randomize;
end;


procedure TFormMain.HelpManualClick(Sender: TObject);
Var
  S : String;
  D : String;
begin
  If FLastClickedDetail Is TMimCustomModule
  Then Begin
    D := FLastClickedDetail.ClassName;
    D := '#Module_' + Copy( D, 2, Length( D));
  End
  Else D := '';
  S := Format( '"%sManual\Index.htm"%s', [ ApplicationPath, D]);
  ShellExecute(
    Handle,
    Nil,
    PChar( S),
    Nil,
    Nil,
    SW_NORMAL
  );
end;

procedure TFormMain.SpeedButtonAllNotesOffClick(Sender: TObject);
begin
  PerformAllNotesOff;
end;

procedure TFormMain.Modulecolor1Click(Sender: TObject);
begin
  SetModuleColor;
end;

procedure TFormMain.Asymmetriccolor1Click(Sender: TObject);
begin
  SetAssymetricColor;
end;

procedure TFormMain.Symmetriccolor1Click(Sender: TObject);
begin
  SetSymmetricColor;
end;

procedure TFormMain.Logiccolor1Click(Sender: TObject);
begin
  SetLogicColor;
end;

procedure TFormMain.Neuroncolor1Click(Sender: TObject);
begin
  SetNeuronColor;
end;

procedure TFormMain.Knobcolor1Click(Sender: TObject);
begin
  SetKnobColor;
end;

procedure TFormMain.LedColoron1Click(Sender: TObject);
begin
  SetLedColorOn;
end;

procedure TFormMain.Ledcoloroff1Click(Sender: TObject);
begin
  SetLedColorOff;
end;

procedure TFormMain.Viewercolor1Click(Sender: TObject);
begin
  SetViewerColor;
end;

procedure TFormMain.Scopecolor1Click(Sender: TObject);
begin
  SetScopeColor;
end;




procedure TFormMain.N6Click(Sender: TObject);
begin
  CutSelection;
end;

procedure TFormMain.Copy1Click(Sender: TObject);
begin
  CopySelection;
end;

procedure TFormMain.Paste1Click(Sender: TObject);
begin
  PasteSelection;
end;

procedure TFormMain.Selectall1Click(Sender: TObject);
begin
  SelectAllModules;
end;

procedure TFormMain.Invertselection1Click(Sender: TObject);
begin
  InvertModuleSelection;
end;

Initialization

  ShowWindow( Application.Handle, SW_HIDE);

end.
