unit FrmRndSet;

{
  BLUE HELL software.

  Copyright (C) 1999 .. 2012, Jan Punter.

  Notes :

    midi componenets needed : http://sourceforge.net/projects/dmidi/
    hires timer needed      : source code included ... I may have stolen that somewhere without
                              acknowleging the source .. somewhere in 1999 or so ...
                              It sure looks a lot like : http://www.programmersheaven.com/download/2818/1/ZipView.aspx
                              but details as to the origin seem absent there too.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ExtCtrls, StdCtrls;

type
  TFormRandomSettings = class(TForm)
    Panel1: TPanel;
    SpeedButtonOk: TSpeedButton;
    SpeedButtonCancel: TSpeedButton;
    EditSeed: TEdit;
    Label1: TLabel;
    CheckBoxRandomized: TCheckBox;
    procedure CheckBoxRandomizedClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpeedButtonCancelClick(Sender: TObject);
    procedure SpeedButtonOkClick(Sender: TObject);
  private
      FRandomSeed : LongInt;
      FRandomized : Boolean;
    Function    Validate: Boolean;
    Procedure   ConfirmDialog;
    Procedure   CancelDialog;
    Procedure   SetRandomSeed( aValue: LongInt);
    Procedure   SetRandomized( aValue: Boolean);
  public
    Property    RandomSeed : LongInt Read FRandomSeed Write SetRandomSeed;
    Property    Randomized : Boolean Read FRandomized Write SetRandomized;
  end;

var
  FormRandomSettings: TFormRandomSettings;

implementation

{$R *.DFM}

// User area

    Function    TFormRandomSettings.Validate: Boolean;
    Begin
      Result := True;
      Try
        If Not Randomized
        Then RandomSeed := StrToInt( EditSeed.Text);
      Except On
        Exception Do
        Begin
          EditSeed.SetFocus;
          ShowMessage( 'Random seed value must be a (decimal) number.');
          Result := False;
        End;
      End;
    End;

    Procedure   TFormRandomSettings.ConfirmDialog;
    Begin
      If Validate
      Then ModalResult := mrOk
      Else ModalResult := mrNone;
    End;

    Procedure   TFormRandomSettings.CancelDialog;
    Begin
      ModalResult := mrCancel;
    End;

    Procedure   TFormRandomSettings.SetRandomSeed( aValue: LongInt);
    Begin
      If FRandomSeed <> aValue
      Then Begin
        FRandomSeed := aValue;
        EditSeed.Text := IntToStr( FRandomSeed);
      End;
    End;

    Procedure   TFormRandomSettings.SetRandomized( aValue: Boolean);
    Begin
      If FRandomized <> aValue
      Then Begin
        FRandomized := aValue;
        CheckBoxRandomized.Checked := FRandomized;
        EditSeed.Enabled := Not FRandomized;
      End;
    End;


// Delphi area

procedure TFormRandomSettings.CheckBoxRandomizedClick(Sender: TObject);
begin
  Randomized := CheckBoxRandomized.Checked;
end;

procedure TFormRandomSettings.FormCreate(Sender: TObject);
begin
  FRandomSeed := -1;
  RandomSeed  := 0;
  FRandomized := False;
  Randomized  := True;
end;

procedure TFormRandomSettings.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 If Shift = []
 Then
   Case Key Of
     VK_RETURN : ConfirmDialog;
     VK_ESCAPE : CancelDialog;
   End;
end;

procedure TFormRandomSettings.SpeedButtonCancelClick(Sender: TObject);
begin
  CancelDialog;
end;

procedure TFormRandomSettings.SpeedButtonOkClick(Sender: TObject);
begin
  ConfirmDialog;
end;

end.
